import React, { useState, useRef, useEffect } from 'react';
import { Card, Select, Button, message, Checkbox, Modal } from 'antd';
import { ProCard } from '@ant-design/pro-Card';
import { DeleteOutlined, CloseOutlined } from '@ant-design/icons';
import From from './From'
import FromBatch from './FromBatch'
const EditFrom = (props) => {
    const [fromdata, setfromdata] = useState([])
    //const [disabled, setdisabled] = useState(false)
    const [sort, setsort] = useState(0)
    useEffect(() => {
        //setfromdata(props.fromdata)
        //props.fromdata=fromdata
        console.log("增加编辑状态值",props.UpdataStatus)
        
        setsort(0)
        if(props.fromdata.length==0){
            setfromdata([])
        }else{
            if(props.UpdataStatus=="update"){
                //setdisabled(true);
                props.fromdata.forEach(x=>{
                    x.disabled=true;
                })
                setfromdata(props.fromdata)
            }
            
        }
    },[props.fromdata])
    //添加工艺步骤
    const onAddClick = (value, option) => {
        //setdisabled(false);
        if(props.UpdataStatus=="update"){
            props.onUpdataStatus("update")
            message.error("当前处于编辑状态无法新增，删除当前编辑工艺后在新增");
        }else{
            console.log("最大序号：",sort)
            if(sort==0){
                setsort(props.maxsort+1)
            }else{
                setsort(sort+1)
            }
            let data = [...fromdata]
            let index = fromdata.length
            console.log(data)
            data.push({ index: index+1, id: '', stepName: '', chnologyId: '', actionJson: '', sort: sort, goodsId: '', goodsAttributeId: '',optiondata: [], propsdata: [], isBatch: true, typeName: '',disabled:false })
            setfromdata(data)
            props.onUpdataStatus("add")
        }
        
    }
    //删除工艺
    const onDelClick = (val) => {
        let data = fromdata.filter(x => x.index != val)
        setfromdata(data);
        //setdisabled(false);
        props.onUpdataStatus("view")
    }
    //选择工艺步骤事件
    const onHandleChange = (value, option, index) => {
        // console.log("value",value)
        console.log("option", option)
        //var newdata=[...fromdata]
        // setisBatch(option.isBatch)
        var sd = props.technologyattralldata.filter(x => x.goodstechnologyId == value);
        var newdata = fromdata.map(x => {
            if (x.index == index) {
                x.propsdata = sd;
                x.isBatch = option.isBatch
                x.typeName = option.label
                x.stepName=option.label
                x.chnologyId=option.value,
                x.sort=props.maxsort+1
                var opdata=[]
                sd.forEach(p => {
                    opdata.push({actionName:p.actionName,actionValue:'',technologyactionId:p.id})
                });
                x.optiondata=opdata
            }
            return x
        })
        setfromdata(newdata)
        //setfromdata()
        console.log("from", newdata)
    }
    //保存
    const onSaveClick=(fromdata)=>{
        props.onSaveClick(fromdata)
        //setdisabled(false);
    }
    return (
        <div>
            {
                fromdata.length > 0 ?
                    fromdata.map((x, index) => {
                        return (
                            <ProCard title={"工序号"+x.sort} bordered bodyStyle={{ padding: 15 }} headStyle={{ padding: '0px 24px' }} style={{ marginBlockEnd: 8 }} extra={<DeleteOutlined onClick={() => { onDelClick(x.index) }} />}>
                                <div style={{ float: 'left', height: '70px', lineHeight: '65px',width: '20%' }}>
                                    <Select name="chnologyId" key={sort} style={{ width: '90px' }} defaultValue={x.chnologyId} disabled={x.disabled} options={props.goodstechnologydata} onChange={async (value, option) => { onHandleChange(value, option, x.index) }}></Select>
                                </div>
                                <div style={{ float: 'left',width: '80%'}}>
                                    {
                                        x.isBatch ?
                                            <From propsdata={x.propsdata} fromdata={fromdata} onSaveClick={onSaveClick}  optiondata={x.optiondata} />
                                            : <FromBatch batchingdata={props.batchingdata} typeName={x.typeName} modalVisible={true} optiondata={x.optiondata} onSaveClick={onSaveClick} fromdata={fromdata}/>
                                    }
                                </div>

                            </ProCard>
                        )
                    }) : ""
            }
            <Button type="dashed" block onClick={onAddClick}>添加工艺</Button>
            {/* <Button type="dashed" block onClick={onSaveClick}>保存</Button> */}
        </div>
    )
}
export default EditFrom;