import { Button, message, Input, Card, Select, Radio, Tag, Upload, Descriptions } from 'antd';
import React, { useState, useRef, useEffect } from 'react';
import { CloseOutlined } from '@ant-design/icons';
import { ProCard } from '@ant-design/pro-Card';
import { BetaSchemaForm } from '@ant-design/pro-form';
import {
  getbyidgoods,
  GetGoodsTechnology,
  GetTechnologyactionList,
  GetTechnologyActionListAll,
  GetGoodsTechnologyAction,
  DeleteGoodsTechnologyAction,
  GetByTypebatching,
  GetDeviceTechnology,
  AddGoodsTechnologyAction
} from '../service';
import style from '../style.less'
import EditCarTable from './EditCarTable'
import EditFrom from './EditFrom'
import useFetchData from '@ant-design/pro-descriptions/lib/useFetchData';
const goodstechnologymaken = (props) => {
  const [attrvalue, setAttrvalue] = useState('');
  const [checkvalue, setCheckvalue] = useState([]);
  const [items, setItems] = useState([]);
  const [goodstechnologydata, setgoodstechnologydata] = useState([]);
  const [technologyattrdata, setTechnologyattrdata] = useState([]);
  const [technologyattralldata, setTechnologyattralldata] = useState([]);
  const [goodsinfo, setGoodsinfo] = useState({});
  const [cardcount, setCardcount] = useState([]);
  const [goodstechnolog, setgoodstechnolog] = useState([]);
  const [maxsort, setmaxsort] = useState(1);
  const [batchingdata, setbatchingdata] = useState([]);
  const [DeviceTechnologydata, setDeviceTechnology] = useState([])
  const [DeviceTechnologyoption, setDeviceTechnologyoption] = useState([])
  const [display, setdisplay] = useState("block")
  const [fromdata, setfromdata] = useState([])
  const [UpdataStatus,setUpdataStatus] = useState('view')
  const [disabled, setdisabled] = useState(false)
  useEffect(() => {
    interdata()
  }, [])
  const interdata = () => {
    getbyidgoods(props.goodsid).then((res) => {
      if (res.succeeded) {
        setGoodsinfo(res.data)
        if (res.data.goodsAttributeList.length == 0) {
          setdisplay("none")
        }
        var it = [
          // {key:'1',label:'',children:(<div><img style={{width:100,height:100}} src={res.data.imgUrl}></img></div>)},
          { key: '1', label: '商品名称', children: res.data.name },
          { key: '2', label: '商品价格', children: res.data.price },
          { key: '3', label: '商品大类', children: res.data.parentTypeIDName },
          { key: '4', label: '商品小类', children: res.data.goodsTypeName },
          { key: '5', label: '商品单位', children: res.data.goodsUintName },
          { key: '6', label: '套餐属性', children: res.data.goodsAttribute == 0 ? '单品' : '套餐' },
        ]
        setItems(it)
      } else {
        message.error("查询商品信息失败");
      }
    });
    GetGoodsTechnology().then((r) => {
      var data = r.data;
      var sd = []
      if (data.length > 0) {
        data.forEach((x) => {
          sd.push({ label: x.name, value: x.id, isBatch: x.isBatch });
        });
        setgoodstechnologydata(sd)
      }
    });
    GetTechnologyActionListAll().then((r) => {
      setTechnologyattralldata(r.data)
    })
    GetGoodsTechnologyAction(props.goodsid).then((r) => {
      if (r.data.length > 0) {
        console.log("已绑定工艺信息",r.data)
        setgoodstechnolog(r.data)
        // 查询最大值
        var max = r.data.reduce(function (prev, current) {
          return (prev.sort > current.sort) ? prev : current;
        });
        setmaxsort(max.sort)
      }
    })
    GetByTypebatching().then((r) => {
      setbatchingdata(r.data)
    })
    GetDeviceTechnology().then((res) => {
      setDeviceTechnology(res.data)
      if (res.data.length > 0) {
        var op = res.data.map(x => {
          return { value: x.id, label: x.deviceName }
        })
        setDeviceTechnologyoption(op)
      }
    })
  }
  const onChangevalue = (e) => {
    const { name, value } = e.target;
    console.log(name)
    console.log(value)
    let names = "";
    let updatedValues = [...checkvalue];
    for (let index = 0; index < goodsinfo.goodsAttributeList.length; index++) {
      if (name === 'radiogroup' + index) {
        // 将第一组的值累加到数组中  
        updatedValues[index] = value;

      }
    }
    goodsinfo.goodsAttributeList.forEach(item => {
      for (let index = 0; index < updatedValues.length; index++) {
        var bs = item.goodsAttributeValueList.find(x => x.goodsAttributeValuId == updatedValues[index])?.attributeValue
        if (bs) {
          names = names + bs;
          if (index < updatedValues.length - 1) {
            names = names + "-"
          }
        }

      }
    })
    setAttrvalue(names)
    setCheckvalue(updatedValues)
  }
  const onClickedit = (e, item, action) => {
    console.log("UpdataStatus",UpdataStatus)
    if(UpdataStatus!="add"){
      let attr = [];
      const obj = {};
      obj.stepName = item.stepName;
      obj.id= item.id;
      obj.chnologyId = item.chnologyId;
      obj.sort = item.sort;
      obj.actionJson=item.actionJson
      obj.optiondata=JSON.parse(item.actionJson)
      obj.propsdata= technologyattralldata.filter(x => x.goodstechnologyId == item.chnologyId)
      obj.isBatch=item.isBatch;
      obj.typeName=item.stepName;

      attr.push(obj)
      setfromdata(attr)
      setUpdataStatus("update")
    }else{
      message.error("请保存当前数据后在编辑");
    }
    
    //setTechnologyattrdata(attr)
  }
  const onClickdele = (e, item, action) => {
    DeleteGoodsTechnologyAction(item.id).then((res) => {
      if (res.data) {
        message.success("删除成功")
        //formRef?.current?.resetFields(...props.technologyattrdata)
        updadata()
      } else {
        message.error("删除失败")
      }
    })
  }
  const updadata = () => {
    GetGoodsTechnologyAction(props.goodsid).then((r) => {
      if (r.data.length > 0) {
        setgoodstechnolog(r.data)
        // 查询最大值
        var max = r.data.reduce(function (prev, current) {
          return (prev.sort > current.sort) ? prev : current;
        });
        setmaxsort(max.sort);
        let attr = { attributes: [] };
        setTechnologyattrdata(attr)
      }
    })
  }
  const handleChange = (value) => {

    let sd = DeviceTechnologydata.find(x => x.id == value);

    if (sd) {
      if (sd.goodsTechnologyInfo.length > 0) {
        let godata = sd.goodsTechnologyInfo.map(x => {
          return { value: x.goodsTechnologyId, label: x.name }
        })
        console.log(godata)
        //setgoodstechnologydata(godata)
      }

    }

  }
  const onUpdataStatus = (val) => {
    setUpdataStatus(val)
  }
  const onSaveClick = (val) => {
    setfromdata(val)
  }
  const onSubmitSaveClick = () => {
    console.log("保存的数据", fromdata)
    let check = true;
    var data = []
    fromdata.forEach(x => {
      let item = {};
      item.id = x.id
      item.stepName = x.stepName;
      item.chnologyId = x.chnologyId;
      item.isBatch=x.isBatch;
      item.sort = x.sort;
      if(x.optiondata.length==0){
        check = false;
      }else{
        item.actionJson = JSON.stringify(x.optiondata);
      }
      item.goodsId = props.goodsid
      item.goodsAttributeId = checkvalue.join(',')
      if (x.chnologyId == "") {
        check = false;
      }
      data.push(item)
    })
    console.log("转化后要保存的数据", data)
    if (data.length > 0 && check) {
      AddGoodsTechnologyAction(data).then((res) => {
        if (res.data) {
          message.success("保存成功")
          setfromdata([])
          updadata()
        } else {
          message.error("保存失败")
        }
      })

    } else {
      message.error("没有要保存的数据或数据格式不正确")
    }
    setUpdataStatus("view")
    setdisabled(false)
  }
  return <>

    <Card bodyStyle={{ padding: 15 }}>
      <div style={{ fontSize: 16, marginBottom: 5, color: '#1890ff', fontWeight: 600 }}>商品信息</div>
      <div style={{ float: 'left' }}><img style={{ width: 100, height: 100 }} src={goodsinfo.imgUrl}></img></div>
      <Descriptions style={{ float: 'left', width: '71%', marginLeft: '10px' }} labelStyle={{ fontSize: 16, fontWeight: 600 }} >

        {
          items.map((x, index) => {
            return (
              <Descriptions.Item key={index} label={x.label}>{x.children}</Descriptions.Item>
            );
          })
        }

      </Descriptions>
    </Card>
    <Card bodyStyle={{ padding: 15 }} style={{ display: display }} >
      <div style={{ fontSize: 16, marginBottom: 5, color: '#1890ff', fontWeight: 600 }}>商品属性</div>
      {
        goodsinfo.goodsAttributeList == undefined ? '' : (
          goodsinfo.goodsAttributeList.map((item, index) => {
            return (
              <div style={{ marginLeft: 10 }}>
                <div>
                  <span style={{ marginRight: 10 }}> <Tag color="blue" style={{ fontSize: 14, fontWeight: 600 }}>{item.attributeName}</Tag>：</span>
                  <span>
                    <Radio.Group name={"radiogroup" + index} buttonStyle="solid" onChange={onChangevalue}>
                      {
                        item.goodsAttributeValueList.map((item, index) => {
                          return (
                            <Radio.Button key={index} name={index} value={item.goodsAttributeValuId} style={{ marginRight: 22, marginTop: 10 }}>{item.attributeValue}</Radio.Button>
                          )
                        })
                      }
                    </Radio.Group>
                  </span>
                </div>
              </div>
            );
          })
        )
      }
    </Card>
    <Card bodyStyle={{ padding: 15 }}>
      <div style={{ fontSize: 16, marginBottom: 5, color: '#1890ff', fontWeight: 600 }}>
        工艺设计
        <Select
          showSearch
          style={{
            width: 200,
          }}
          placeholder="请选择设备"
          optionFilterProp="children"
          filterOption={(input, option) => (option?.label ?? '').includes(input)}
          filterSort={(optionA, optionB) =>
            (optionA?.label ?? '').toLowerCase().localeCompare((optionB?.label ?? '').toLowerCase())
          }
          onChange={handleChange}
          options={DeviceTechnologyoption}
        />
      </div>

      <ProCard split="vertical">
        {/* extra={<Button type="primary">保存</Button>} */}
        <ProCard title="编辑工艺" type='inner' colSpan="33%" bodyStyle={{ padding: 5 }} headerBordered headStyle={{ paddingLeft: '45%' }} extra={<Button onClick={() => { onSubmitSaveClick() }}>保存</Button>}>
          <div style={{ textAlign: 'center', marginBottom: 10, color: 'brown' }}>{attrvalue}</div>
          <EditFrom disabled={disabled} fromdata={fromdata} maxsort={maxsort} UpdataStatus={UpdataStatus} onUpdataStatus={onUpdataStatus} onSaveClick={onSaveClick} goodstechnologydata={goodstechnologydata} technologyattralldata={technologyattralldata} batchingdata={batchingdata} />
          {/* <EditCarTable maxsort={maxsort} batchingdata={batchingdata} updadata={updadata} goodsid={props.goodsid} technologyattralldata={technologyattralldata} checkvalue={checkvalue} technologyattrdata={technologyattrdata} goodstechnologydata={goodstechnologydata} /> */}
          {/* <Button type="dashed" style={{ marginTop: 10 }} onClick={onClickadd} icon={<PlusOutlined />} block>添加工艺</Button> */}
        </ProCard>
        <ProCard title="查看工艺" type='inner' headStyle={{ paddingLeft: '45%' }} bodyStyle={{ padding: 5 }} headerBordered>
          <div style={{ height: 360 }}>
            {
              goodstechnolog == undefined ? '' : (
                goodstechnolog.map((item, index) => {
                  var action = JSON.parse(item.actionJson)
                  return (
                    <ProCard title={"工序号" + item.sort} bordered bodyStyle={{ padding: 5 }} headStyle={{ padding: '0px 5px' }} extra={[<Button type="link" onClick={(e) => { onClickedit(e, item, action) }}>编辑</Button>, <CloseOutlined onClick={(e) => { onClickdele(e, item, action) }} />]} style={{
                      marginBlockEnd: 8, width: 353, float: 'left', height: '200px', marginRight: '10px', 'overflow-y': 'scroll'
                    }}>
                      <div style={{ lineHeight: '200px' }}>
                        <div className={style['formlable']} style={{ float: 'left', height: '70px', lineHeight: '65px' }}>{item.stepName}</div>
                        <div style={{ float: 'left', marginBottom: '5px', width: '67%' }}>
                          {
                            action.map(x => {
                              return (
                                <div style={{ float: 'left', marginBottom: '5px' }}>
                                  <div className={style['formlable']} style={{ display: 'block', float: 'left' }}>{x.actionName}</div>
                                  <div className={style['formlable']} style={{ display: 'block', float: 'left' }}> {x.actionValue}</div>
                                </div>
                              )

                            })
                          }
                        </div>
                      </div>
                    </ProCard>
                  )
                })
              )
            }
          </div>
        </ProCard>
      </ProCard>
    </Card>
  </>

}
export default goodstechnologymaken;